import React, {useEffect, useMemo, useState} from "react";
import {Slate, withReact} from "slate-react";
import {createEditor, Descendant} from "slate";
import {slateNodesToInsertDelta, withYjs, YjsEditor} from "@slate-yjs/core";
import * as Y from "yjs"

// const v: Descendant = {
//     children: [], text: ""
//
// }
const initialValue:Descendant[] = [{
    text: 'paragraph',
    children: [{text: 'A line of text in a paragraph.'}],
}]
export const Editor: React.FC = () => {

    const [value, setValue] = useState(initialValue)
    // Create a yjs document and get the shared type
    const sharedType = useMemo(() => {
        const yDoc = new Y.Doc()
        const sharedType = yDoc.get("content", Y.XmlText) as unknown as Y.XmlText

        // Load the initial value into the yjs document
        sharedType.applyDelta(slateNodesToInsertDelta(initialValue))

        return sharedType
    }, [])

    const editor = useMemo(() => withYjs(withReact(createEditor()),sharedType), [])
    useEffect(()=>{
        YjsEditor.connected(editor);
        return ()=> YjsEditor.disconnect(editor)
    },[editor])

    return (
        <Slate
            editor={editor}
            value={value}
            onChange={setValue}
        />
    )
}
