import {Quill} from "react-quill";
import {ReplaceItemAttribute} from "../../types/editor.ts";
import {EDITOR} from "./editor.ts";

// eslint-disable-next-line react-refresh/only-export-components
const Inline = Quill.import('blots/inline');

/**
 * 替换对象
 */
class ReplaceParserBlot extends Inline {
    static tagName = "span";
    static className = "text-replace-item";
    static blotName = "replace";

    static create(value: ReplaceItemAttribute) {
        console.log('ReplaceParserBlot==>create', value)
        // 创建元素对象
        const node = super.create('span') as HTMLSpanElement;
        if (value && value.id) {
            node.setAttribute("data-replace", 'id_' + value.id);
            node.setAttribute("data-replace-text", (value.text || value.origin));
            node.setAttribute("data-replace-type", value.type);
            node.classList.add(`replace-type-${value.type}`)
            if (value.processed) {
                node.classList.add(`processed`, `processed-${value.processed}`)
            }
            node.onclick = () => {
                EDITOR.trigger('demo', value)

                // console.log(node, value,this)
                // const e = new Event('replace-item-select')
                // node.dispatchEvent(e)
            }
        }
        return node;
    }

    onClick() {
        console.log('~~~~~~~', this)
    }

    static value(node: HTMLElement) {
        console.log('333', node)
        return {
            // alt: node.getAttribute('alt'),
            id: node.getAttribute('data-replace')?.replace('id_', ''),
            text: node.getAttribute('data-replace-text'),
            type: node.getAttribute('data-replace-type')
        };
    }

    // 从对象解析数据
    static formats(node: HTMLElement) {
        // console.log('22', node)
        return {
            id: node.getAttribute('data-replace')?.replace('id_', ''),
            text: node.getAttribute('data-replace-text'),
            type: node.getAttribute('data-replace-type')
        };
    }

    // format(name, value) {
    // console.log('name,value==>', name, value)
    // if (name === 'link' && value) {
    //     this.domNode.setAttribute('href', value);
    // } else {
    //     super.format(name, value);
    // }
    // }

    // formats() {
    //     const formats = super.formats();
    //     console.log('formats', this.domNode, formats)
    //     formats['replace'] = ReplaceParserBlot.formats(this.domNode, formats);
    //     return formats;
    // }
}

Quill.register(ReplaceParserBlot, true);
