import React, {useRef} from "react";
import {Button, message, Space} from "antd";

export const Test: React.FC = () => {
    const div = useRef<HTMLDivElement>(null)
    const [messageApi, contextHolder] = message.useMessage();

    const selectSpan = (selector: string) => {
        return () => {
            if (!div.current) {
                return;
            }
            const span = div.current.querySelector(selector);
            if (!span) return;
            const sel = window.getSelection();
            sel?.selectAllChildren(span);
        }
    }
    const showSelection = async () => {
        const sel = window.getSelection();
        if (sel) {
            const str = sel.toString();
            messageApi.info(str || '没有选区')
        }
    }
    return (<div ref={div} style={{width: '90%', margin: 'auto'}}>
            {contextHolder}
            <div style={{padding: 15}}>
                <Space>
                    <Button type="primary" onClick={selectSpan('.js')}>select js</Button>
                    <Button type="primary" onClick={selectSpan('.cq')}>select cq</Button>
                    <Button type="primary" onClick={showSelection}>get selection</Button>
                </Space>
            </div>
            <div className="container">
                <div className="ql-editor" data-gramm="false" contentEditable="true">
                    <p className="ql-align-justify">最近不少江苏的网友反馈网站无法反馈，其中包括主页、论坛、图床、会员商城等均无法访问。</p>
                    <p className="ql-align-justify">经过调查，是由于 <span className="js">江苏</span> 、<span
                        className="cq">重庆</span> 两个地区的反诈系统将本站域名拦截。</p>
                    <p className="ql-align-justify">我在访问其他服务器在境外的其他网站时，也看到有江苏用户反馈被拦截，看来江苏反诈最近是拦截了一大批网站，这是要开启白名单的节奏。</p>
                </div>
            </div>
        </div>
    )
}
