export  type ReplaceItemAttribute = {
    processed?: 'check' | 'cancel';
    origin: string;
    text?: string;
    /**
     * 地名纠错 成语纠错
     */
    type: 'words' | 'address' | 'delete' | string;
    id?: number;
}
export type EditorFormat = {
    bold?: boolean;
    underline?: boolean;
    italic?: boolean;
    strike?: boolean;
    indent?: number;
    link?: string;
    align?: 'center' | 'right' | 'justify';
    replace?: ReplaceItemAttribute
}
type EditorContentItem = {
    insert?: string;
    retain?: number;
    delete?: number;
    attributes?: EditorFormat;
}
export type EditorContent = {
    ops: EditorContentItem[]
}
// type TextFontAttrs = 'bold' | 'italic' | 'underline' | 'through'
export type WangEditorTextItem = {
    text: string;
    bold?: boolean;
    italic?: boolean;
    underline?: boolean;
    through?: boolean;
    fontSize?: string
    fontFamily?: string
    color?: string
}
type ProofreadType = 'words' | 'address' | 'delete' | 'insert';
export const PROOFREAD_TYPE_DESC: {
    [key in ProofreadType]: string
} = {
    words: '别字,建议选用"%text%"',
    address: '地名错误,建议选用"%text%"',
    delete: '多余内容,建议删除',
    insert: '新增,插入"%text%"',
}

export type WangEditorProofreadElement = {
    type: 'proofread';
    proofread: {
        origin: string;
        text: string;
        type: ProofreadType;
        description?: string;
        id?: number;
    },
    children: WangEditorTextItem[]
}
export type WangEditorContentChildren = WangEditorTextItem | WangEditorProofreadElement
export type WangEditorContent = {
    type: 'paragraph' | string;
    children: WangEditorContentChildren[];
}
